import es
import gamethread
import random

changeTeamRespawnTime = 5
respawnTime = 20
livinglist = []
ghostlist = []
location = ""

def load():
	es.msg("#multi", "#lightgreen[Your-Versus-Here]:#green Loaded.")
	es.regsaycmd("!infected", "examples/versus_l4d/join_infected", "")
	es.regsaycmd("!survivor", "examples/versus_l4d/join_survivor", "")
	es.regsaycmd("!spectator", "examples/versus_l4d/join_spectator", "")
	es.regclientcmd("jointeam", "examples/versus_l4d/jointeam", "")
	es.set("sb_all_bot_team", "1")
	for userid in es.createplayerlist():
		if es.getplayerteam(userid) == 3:
			canceldelays(userid)
			gamethread.delayedname(5, "respawn_%s"%userid, respawnPlayer, userid)

def unload():
	es.msg("#multi", "#lightgreen[Your-Versus-Here]:#green Unloaded.")
	es.unregsaycmd("!infected")
	es.unregsaycmd("!survivor")
	es.unregsaycmd("!spectator")
	es.unregclientcmd("jointeam")
	es.set("sb_all_bot_team", "0")

def round_freeze_end(ev):
	gamethread.delayed(15, checkRespawns)

def checkRespawns():
	for userid in es.createplayerlist():
		if es.getplayerteam(userid) == 3:
			es.tell(userid, "#multi", "#lightgreen[Your-Versus-Here]:#green You will be respawned in %d seconds!" % changeTeamRespawnTime)
			canceldelays(userid)
			gamethread.delayedname(changeTeamRespawnTime, "respawn_%s"%userid, respawnPlayer, userid)			
		elif es.getplayerteam(userid) == 1:
			canceldelays(userid)
			gamethread.delayedname(15, "team_%s"%userid, selectteam, (userid,3))

def canceldelays(userid):
	gamethread.cancelDelayed("team_%s"%userid)
	gamethread.cancelDelayed("respawn_%s"%userid)

def player_disconnect(ev):
	if not ev["userid"]:
		return
	userid = int(ev["userid"])
	if es.isbot(userid):
		return
	canceldelays(userid)

def player_death(ev):
	if not ev["userid"]:
		return
	userid = int(ev["userid"])
	if not es.getplayerteam(userid) == 3:
		return
	if es.isbot(userid):
		return
	es.tell(userid, "#multi", "#lightgreen[Your-Versus-Here]:#green You will be respawned in %d seconds!" % respawnTime)
	canceldelays(userid)
	gamethread.delayedname(respawnTime, "respawn_%s"%userid, respawnPlayer, userid)

def join_infected():
	userid = es.getcmduserid()
	selectteam(userid, 3)

def join_survivor():
	userid = es.getcmduserid()
	selectteam(userid, 2)

def join_spectator():
	userid = es.getcmduserid()
	selectteam(userid, 1)

def jointeam():
	userid = es.getcmduserid()
	if es.getargc() < 1:
		es.tell(userid, "#multi", "#lightgreen[Your-Versus-Here]:#green Syntax: jointeam <spectator/survivor/infected/sp/s/i/1/2/3>")
		return
	team = es.getargv(1)
	selectteam(userid,team)

def selectteam(userid,team):
	if team in ["survivor", "s", "2", 2]:
		if es.getplayerteam(userid) == 2:
			es.tell(userid, "#multi", "#lightgreen[Your-Versus-Here]:#green You are already a survivor.")
			return
		if teamcount(2) > 3:
			es.tell(userid, "#multi", "#lightgreen[Your-Versus-Here]:#green Survivor team is full.")
			return
		es.tell(userid, "#multi", "#lightgreen[Your-Versus-Here]:#green You were switched to the survivor team.")
		es.setplayerprop(userid,"CTerrorPlayer.m_isGhost",0)
		sb_takecontrol(userid)
	elif team in ["infected", "i", "3", 3]:
		if es.getplayerteam(userid) == 3:
			es.tell(userid, "#multi", "#lightgreen[Your-Versus-Here]:#green You are already an infected.")
			return
		if teamcount(3) > 3:
			es.tell(userid, "#multi", "#lightgreen[Your-Versus-Here]:#green Infected team is full.")
			return
		es.tell(userid, "#multi", "#lightgreen[Your-Versus-Here]:#green You were switched to the infected team.")
		es_changeteam(userid,3)
		es.tell(userid, "#multi", "#lightgreen[Your-Versus-Here]:#green You will be respawned in %d seconds!" % changeTeamRespawnTime)
		canceldelays(userid)
		gamethread.delayedname(changeTeamRespawnTime, "respawn_%s"%userid, respawnPlayer, userid)
	elif team in ["spectator", "sp", "1", 1]:
		if es.getplayerteam(userid) == 1:
			es.tell(userid, "#multi", "#lightgreen[Your-Versus-Here]:#green You are already a spectator.")
			return
		es.tell(userid, "#multi", "#lightgreen[Your-Versus-Here]:#green You were switched to the spectator team.")
		es.setplayerprop(userid,"CTerrorPlayer.m_isGhost",0)
		es_changeteam(userid,1)
	else:
		es.tell(userid, "#multi", "#lightgreen[Your-Versus-Here]:#green Syntax: jointeam <spectator/survivor/infected/sp/s/i/1/2/3>")

def teamcount(teamid):
	count = 0
	for userid in es.createplayerlist():
		if not es.isbot() and es.getplayerteam == teamid:
			count += 1
	return count

def respawnPlayer(userid):
	if not userid in es.createplayerlist():
		return
	if not es.getplayerteam(userid) == 3:
		return
	if not isdead(userid):
		return
	prespawn()
	infectedtype = getinfectedtype()
	z_spawn(userid,infectedtype)
	es.server.queuecmd("es_xset t_userid %s;es_xdoblock examples/versus_l4d/postspawn"%userid)

def prespawn():
	del livinglist[:]
	del ghostlist[:]
	for userid in es.createplayerlist():
		if es.getplayerteam(userid) == 3 and not es.isbot(userid):
			if es.getplayerprop(userid,"CTerrorPlayer.m_isGhost"):
				ghostlist.append(userid)
				es.setplayerprop(userid,"CTerrorPlayer.m_isGhost",0)
			if not isdead(userid):
				livinglist.append(userid)

def postspawn():
	for userid in es.createplayerlist():
		if es.getplayerteam(userid) == 3 and not es.isbot(userid):
			if userid in ghostlist:
				es.setplayerprop(userid,"CTerrorPlayer.m_isGhost",1)
			if not isdead(userid) and not userid in livinglist:
				es.tell(userid, "#multi", "#lightgreen[Your-Versus-Here]:#green You have been spawned as a ghost. Hide and left-click to spawn.")
				es.setplayerprop(userid,"CTerrorPlayer.terrorlocaldata.m_isCulling",1)
				es.server.queuecmd("es_cexec %s +use"%userid)
	userid = int(es.ServerVar("t_userid"))
	if isdead(userid):
		canceldelays(userid)
		gamethread.delayedname(2, "respawn_%s"%userid, respawnPlayer, userid)

def tank_spawn(ev):
	if not ev["userid"]:
		return
	userid = int(ev["userid"])
	if not es.getplayerteam(userid) == 3:
		return
	if not es.isbot(userid):
		es.setplayerprop(userid,"CTerrorPlayer.m_isGhost",0)
		es.tell(userid, "#multi", "#lightgreen[Your-Versus-Here]:#green You are now a tank. Smash some people up!")
		if not location == "":
			es_setpos(userid,location)
		return
	tuserid = getinfid()
	if tuserid == -1:
		return
	global location
	location = es.getplayerprop(userid,"CBaseEntity.m_vecOrigin")
	kill(userid)
	z_spawn(tuserid,"tank")
	# es.server.queuecmd("es_xset t_location %s;es_xdoblock examples/versus_l4d/findtank"%location)
	
# def findtank():
	# location = str(es.ServerVar("t_location"))
	# for userid in es.createplayerlist():
		# if es.getplayerteam(userid) == 3 and not isdead(userid) and getinfectedname(userid) == "tank":
			# if es.isbot(userid):
				# tuserid = getinfid()
				# if not tuserid == -1:
					# kill(userid)
					# z_spawn(tuserid,"tank")
					# es.server.queuecmd("es_xset t_location %s;es_xdoblock examples/versus_l4d/findtank"%location)
					# return
			# es.setplayerprop(userid,"CTerrorPlayer.m_isGhost",0)
			# es.tell(userid, "#multi", "#lightgreen[Your-Versus-Here]:#green You are now a tank. Smash some people up!")
			# es_setpos(userid,location)

def getinfid():
	for userid in es.createplayerlist():
		if es.getplayerteam(userid) == 3 and isdead(userid) and not es.isbot(userid):
			return userid
	for userid in es.createplayerlist():
		if es.getplayerteam(userid) == 3 and not es.isbot(userid):
			kill(userid)
			return userid
	return -1

def kill(userid):
	es.server.queuecmd("es_flags remove cheat kill;es_sexec %s kill;es_flags add cheat kill"%userid)	

def z_spawn(userid,infectedtype):
	es.server.queuecmd("es_flags remove cheat z_spawn;es_sexec %s %s;es_flags add cheat z_spawn"%(userid,"z_spawn %s"%infectedtype))

def sb_takecontrol(userid):
	es.server.queuecmd("es_flags remove cheat sb_takecontrol;es_sexec %s sb_takecontrol;es_flags add cheat sb_takecontrol"%userid)

def es_changeteam(userid,teamnum):
	es.server.queuecmd("es_changeteam %s %s"%(userid,teamnum))

def es_setpos(userid,location):
	x,y,z = location.split(",")
	es.server.queuecmd("es_setpos %s %s %s %s"%(userid,x,y,z))

def isdead(userid):
	return es.createplayerlist(userid)[userid]["isdead"]

def getinfectedtype():
	infectedlist = ["boomer", "spitter", "hunter", "smoker", "jockey", "charger"]
	for userid in es.createplayerlist():
		infectedname = getinfectedname(userid)
		if es.getplayerteam(userid) == 3 and infectedname in infectedlist:
			infectedlist.remove(infectedname)
	if len(infectedlist) == 0:
		return "hunter"
	return random.choice(infectedlist)

def getinfectedname(userid):
	if es.getplayerprop(userid,"CTerrorPlayer.m_zombieClass") == 1:
		return "smoker"
	elif es.getplayerprop(userid,"CTerrorPlayer.m_zombieClass") == 2:
		return "boomer"
	elif es.getplayerprop(userid,"CTerrorPlayer.m_zombieClass") == 3:
		return "hunter"
	elif es.getplayerprop(userid,"CTerrorPlayer.m_zombieClass") == 4:
		return "spitter"
	elif es.getplayerprop(userid,"CTerrorPlayer.m_zombieClass") == 5:
		return "jockey"
	elif es.getplayerprop(userid,"CTerrorPlayer.m_zombieClass") == 6:
		return "charger"
	elif es.getplayerprop(userid,"CTerrorPlayer.m_zombieClass") == 8:
		return "tank"
	return ""